import 'dart:convert';

import 'dart:typed_data';
import 'package:encrypt/encrypt.dart';
import 'package:pointycastle/asymmetric/api.dart';

Key aesKey;
RSAPublicKey robotPubKey;

void generateAESKey() {
  //aesKey = Key.fromSecureRandom(16);
  aesKey = Key.fromUtf8("mysecretkey.1234");
}

Uint8List encryptPayload(Uint8List data) {
  final iv = IV.fromLength(16);
  final encrypter = Encrypter(AES(aesKey));
  final encrypted = encrypter.encryptBytes(data, iv: iv);
  return encrypted.bytes;
}

Uint8List decryptPayload(Uint8List data) {
  final iv = IV.fromLength(16);
  final encrypter = Encrypter(AES(aesKey));
  final decrypted = encrypter.decryptBytes(Encrypted(data), iv: iv);
  return Uint8List.fromList(decrypted);
}

RSAPublicKey parsePublicKey(Uint8List pub) {
  final parser = RSAKeyParser();
  return parser.parse(utf8.decode(pub)) as RSAPublicKey;
}
